<template lang="pug">

  .container
    .activity__block
      app-create-link(
      :slug="createEventSlug"
      :linkText="linkText")

    app-data-grid(
      :loading="pageLoading"
      :dataArray="users.users"
      :changePage="changePage"
      :columnNameWidth="dataGridLinkWidth"
      :linkName="dataGridLinkName"
      :activityView="true"
      :propDataGrid='propDataGrid'
      :deletePermission="'isFormCreator'"
      :editPermission="'isFormEditor'"
      @delete-item="deleteCategoriesItem"
      :paginationObj="users.pagination"
      :childComponent="'users/'")

</template>

<script>
import CreateLink from '../../../components/admin/CreateLink.vue';
import DataGrid from '../../../components/admin/DataGrid.vue';

export default {
  layout: 'admin',
  name: 'Users',
  components: {
    'app-create-link': CreateLink,
    'app-data-grid': DataGrid
  },
  async asyncData(app) {
    let { data } = await app.$axios.get('/api/v1/users', {
      params: {
        sort: {
          id: -1
        },
        pagination: {
          perPage: 10,
          currentPage: 1
        }
      }
    });
    return { users: data };
  },
  data() {
    return {
      perPage: 10,
      page: 1,
      pageLoading: false,
      linkText: 'клиента',
      dataGridLinkName: {
        name: 'Email',
        attrName: 'email'
      },
      propDataGrid: [
        {
          name: 'fullName',
          label: 'ФИО',
          width: '220'
        },
        {
          name: 'created_at',
          label: 'Дата создания',
          width: '220'
        }
      ],
      dataGridLinkWidth: '350',
      createEventSlug: '/admin/users/new-user',
      formLoad: true
    };
  },
  created() {
    this.$store.commit('pages', []);
    this.$store.commit('headingTitle', 'Клиенты');
    this.$store.commit('publicLink', '');
    this.$store.commit('id', null);
  },
  mounted() {
    this.createDate();
    this.fullName();
    this.$nextTick(() => {
      window.addEventListener('resize', this.getWindowWidth);
    });

    this.getWindowWidth();
  },
  methods: {
    createDate() {
      if (this.users.users.length) {
        this.users.users.forEach(item => {
          item.created_at = `${this.$moment(item.created_at).format(
            'D.MM.YY'
          )}, в ${this.$moment(item.created_at).format('H:mm')}`;
        });
      }
    },
    fullName() {
      if (this.users.users.length) {
        this.users.users.forEach(item => {
          item.fullName = item.lastName
            ? `${item.lastName} ${
                item.firstName && item.middleName
                  ? item.firstName[0] + '.'
                  : item.firstName || ''
              }${item.middleName ? item.middleName[0] + '.' : ''}`
            : '-';
        });
      }
    },
    deleteCategoriesItem(id) {
      this.pageLoading = true;
      this.$axios
        .delete(`/api/v1/users/${id}`)
        .then(() => {
          this.$axios
            .get('/api/v1/users', {
              params: {
                sort: {
                  id: -1
                },
                pagination: {
                  perPage: this.perPage,
                  currentPage: this.page
                }
              }
            })
            .then(data => {
              this.users = data.data;
              let pagination = data.data.pagination;
              if (
                Math.ceil(pagination.totalPageCount / pagination.perPage) <
                  pagination.currentPage &&
                pagination.currentPage - 1 > 0
              ) {
                this.changePage(pagination.currentPage - 1);
              }
              this.createDate();
              this.pageLoading = false;
              this.$message.warning('Успешно удалено!');
            });
        })
        .catch(() => {
          this.formLoad = false;
          this.$message.error('Ошибка удаления!');
        });
    },
    changePage(value) {
      this.formLoad = true;
      this.page = value;
      this.$axios
        .get('/api/v1/users', {
          params: {
            sort: {
              id: -1
            },
            pagination: {
              perPage: this.perPage,
              currentPage: value
            }
          }
        })
        .then(data => {
          this.users = data.data;
          this.createDate();
          this.formLoad = false;
        });
    },
    getWindowWidth() {
      if (this.$parent.$currentViewport.label === 'desktop-medium') {
        this.dataGridLinkWidth = '300';
      } else if (
        this.$parent.$currentViewport.label === 'mobile' ||
        this.$parent.$currentViewport.label === 'tablet'
      ) {
        this.dataGridLinkWidth = '250';
      } else {
        this.dataGridLinkWidth = '350';
      }
    }
  }
};
</script>
